<!DOCTYPE HTML>
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (11.0.9) on Wed Oct 28 16:08:51 UTC 2020 -->
<title>mxGraphAnalysis (JGraph X 4.2.2 API Specification)</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta name="dc.created" content="2020-10-28">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<link rel="stylesheet" type="text/css" href="../../../jquery/jquery-ui.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
<script type="text/javascript" src="../../../jquery/jszip/dist/jszip.min.js"></script>
<script type="text/javascript" src="../../../jquery/jszip-utils/dist/jszip-utils.min.js"></script>
<!--[if IE]>
<script type="text/javascript" src="../../../jquery/jszip-utils/dist/jszip-utils-ie.min.js"></script>
<![endif]-->
<script type="text/javascript" src="../../../jquery/jquery-3.5.1.js"></script>
<script type="text/javascript" src="../../../jquery/jquery-ui.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="mxGraphAnalysis (JGraph X 4.2.2 API Specification)";
        }
    }
    catch(err) {
    }
//-->
var data = {"i0":10,"i1":10,"i2":10,"i3":9,"i4":10,"i5":10,"i6":10,"i7":9,"i8":10,"i9":10};
var tabs = {65535:["t0","All Methods"],1:["t1","Static Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
var pathtoroot = "../../../";
var useModuleDirectories = true;
loadScripts(document, 'script');</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<header role="banner">
<nav role="navigation">
<div class="fixedNav">
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a id="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxGraphAnalysis.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<ul class="navListSearch">
<li><label for="search">SEARCH:</label>
<input type="text" id="search" value="search" disabled="disabled">
<input type="reset" id="reset" value="reset" disabled="disabled">
</li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
</div>
<div class="navPadding">&nbsp;</div>
<script type="text/javascript"><!--
$('.navPadding').css('padding-top', $('.fixedNav').css("height"));
//-->
</script>
</nav>
</header>
<!-- ======== START OF CLASS DATA ======== -->
<main role="main">
<div class="header">
<div class="subTitle"><span class="packageLabelInType">Package</span>&nbsp;<a href="package-summary.html">import hk.quantr.mxgraph.analysis</a></div>
<h2 title="Class mxGraphAnalysis" class="title">Class mxGraphAnalysis</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li>java.lang.Object</li>
<li>
<ul class="inheritance">
<li>import hk.quantr.mxgraph.analysis.mxGraphAnalysis</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<hr>
<pre>public class <span class="typeNameLabel">mxGraphAnalysis</span>
extends java.lang.Object</pre>
<div class="block">A singleton class that provides algorithms for graphs. Assume these
 variables for the following examples:<br>
 <code>
 mxICostFunction cf = mxDistanceCostFunction();
 Object[] v = graph.getChildVertices(graph.getDefaultParent());
 Object[] e = graph.getChildEdges(graph.getDefaultParent());
 mxGraphAnalysis mga = mxGraphAnalysis.getInstance();
 </code>
 
 <h3>Shortest Path (Dijkstra)</h3>
 
 For example, to find the shortest path between the first and the second
 selected cell in a graph use the following code: <br>
 <br>
 <code>Object[] path = mga.getShortestPath(graph, from, to, cf, v.length, true);</code>
 
 <h3>Minimum Spanning Tree</h3>
 
 This algorithm finds the set of edges with the minimal length that connect
 all vertices. This algorithm can be used as follows:
 <h5>Prim</h5>
 <code>mga.getMinimumSpanningTree(graph, v, cf, true))</code>
 <h5>Kruskal</h5>
 <code>mga.getMinimumSpanningTree(graph, v, e, cf))</code>
 
 <h3>Connection Components</h3>
 
 The union find may be used as follows to determine whether two cells are
 connected: <code>boolean connected = uf.differ(vertex1, vertex2)</code>.</div>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis"><code>mxICostFunction</code></a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Field</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected static <a href="mxGraphAnalysis.html" title="class in import hk.quantr.mxgraph.analysis">mxGraphAnalysis</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#instance">instance</a></span></code></th>
<td class="colLast">
<div class="block">Holds the shared instance of this class.</div>
</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ======== CONSTRUCTOR SUMMARY ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.summary">
<!--   -->
</a>
<h3>Constructor Summary</h3>
<table class="memberSummary">
<caption><span>Constructors</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier</th>
<th class="colSecond" scope="col">Constructor</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>protected </code></td>
<th class="colConstructorName" scope="row"><code><span class="memberNameLink"><a href="#%3Cinit%3E()">mxGraphAnalysis</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
</table>
</li>
</ul>
</section>
<!-- ========== METHOD SUMMARY =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t1" class="tableTab"><span><a href="javascript:show(1);">Static Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colSecond" scope="col">Method</th>
<th class="colLast" scope="col">Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>protected <a href="mxFibonacciHeap.html" title="class in import hk.quantr.mxgraph.analysis">mxFibonacciHeap</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#createPriorityQueue()">createPriorityQueue</a></span>()</code></th>
<td class="colLast">
<div class="block">Hook for subclassers to provide a custom fibonacci heap.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>protected <a href="mxUnionFind.html" title="class in import hk.quantr.mxgraph.analysis">mxUnionFind</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#createUnionFind(java.lang.Object%5B%5D)">createUnionFind</a></span>&#8203;(java.lang.Object[]&nbsp;v)</code></th>
<td class="colLast">
<div class="block">Hook for subclassers to provide a custom union find structure.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code><a href="mxUnionFind.html" title="class in import hk.quantr.mxgraph.analysis">mxUnionFind</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getConnectionComponents(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object%5B%5D,java.lang.Object%5B%5D)">getConnectionComponents</a></span>&#8203;(<a href="../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                       java.lang.Object[]&nbsp;v,
                       java.lang.Object[]&nbsp;e)</code></th>
<td class="colLast">
<div class="block">Returns a union find structure representing the connection components of
 G=(E,V).</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>static <a href="mxGraphAnalysis.html" title="class in import hk.quantr.mxgraph.analysis">mxGraphAnalysis</a></code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getInstance()">getInstance</a></span>()</code></th>
<td class="colLast">&nbsp;</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>java.lang.Object[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getMinimumSpanningTree(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object%5B%5D,import hk.quantr.mxgraph.analysis.mxICostFunction,boolean)">getMinimumSpanningTree</a></span>&#8203;(<a href="../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                      java.lang.Object[]&nbsp;v,
                      <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf,
                      boolean&nbsp;directed)</code></th>
<td class="colLast">
<div class="block">Returns the minimum spanning tree (MST) for the graph defined by G=(E,V).</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>java.lang.Object[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getMinimumSpanningTree(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object%5B%5D,java.lang.Object%5B%5D,import hk.quantr.mxgraph.analysis.mxICostFunction)">getMinimumSpanningTree</a></span>&#8203;(<a href="../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                      java.lang.Object[]&nbsp;v,
                      java.lang.Object[]&nbsp;e,
                      <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf)</code></th>
<td class="colLast">
<div class="block">Returns the minimum spanning tree (MST) for the graph defined by G=(E,V).</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>java.lang.Object[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#getShortestPath(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object,java.lang.Object,import hk.quantr.mxgraph.analysis.mxICostFunction,int,boolean)">getShortestPath</a></span>&#8203;(<a href="../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
               java.lang.Object&nbsp;from,
               java.lang.Object&nbsp;to,
               <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf,
               int&nbsp;steps,
               boolean&nbsp;directed)</code></th>
<td class="colLast">
<div class="block">Returns the shortest path between two cells or their descendants
 represented as an array of edges in order of traversal.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>static void</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#setInstance(import hk.quantr.mxgraph.analysis.mxGraphAnalysis)">setInstance</a></span>&#8203;(<a href="mxGraphAnalysis.html" title="class in import hk.quantr.mxgraph.analysis">mxGraphAnalysis</a>&nbsp;instance)</code></th>
<td class="colLast">
<div class="block">Sets the shared instance of this class.</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code><a href="../view/mxCellState.html" title="class in import hk.quantr.mxgraph.view">mxCellState</a>[]</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#sort(import hk.quantr.mxgraph.view.mxCellState%5B%5D,import hk.quantr.mxgraph.analysis.mxICostFunction)">sort</a></span>&#8203;(<a href="../view/mxCellState.html" title="class in import hk.quantr.mxgraph.view">mxCellState</a>[]&nbsp;states,
    <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf)</code></th>
<td class="colLast">
<div class="block">Returns a sorted set for <code>cells</code> with respect to
 <code>cf</code>.</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>double</code></td>
<th class="colSecond" scope="row"><code><span class="memberNameLink"><a href="#sum(import hk.quantr.mxgraph.view.mxCellState%5B%5D,import hk.quantr.mxgraph.analysis.mxICostFunction)">sum</a></span>&#8203;(<a href="../view/mxCellState.html" title="class in import hk.quantr.mxgraph.view">mxCellState</a>[]&nbsp;states,
   <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf)</code></th>
<td class="colLast">
<div class="block">Returns the sum of all cost for <code>cells</code> with respect to
 <code>cf</code>.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a id="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.Object</h3>
<code>clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait</code></li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a id="instance">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>instance</h4>
<pre>protected static&nbsp;<a href="mxGraphAnalysis.html" title="class in import hk.quantr.mxgraph.analysis">mxGraphAnalysis</a> instance</pre>
<div class="block">Holds the shared instance of this class.</div>
</li>
</ul>
</li>
</ul>
</section>
<!-- ========= CONSTRUCTOR DETAIL ======== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="constructor.detail">
<!--   -->
</a>
<h3>Constructor Detail</h3>
<a id="&lt;init&gt;()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>mxGraphAnalysis</h4>
<pre>protected&nbsp;mxGraphAnalysis()</pre>
</li>
</ul>
</li>
</ul>
</section>
<!-- ============ METHOD DETAIL ========== -->
<section role="region">
<ul class="blockList">
<li class="blockList"><a id="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a id="getInstance()">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getInstance</h4>
<pre class="methodSignature">public static&nbsp;<a href="mxGraphAnalysis.html" title="class in import hk.quantr.mxgraph.analysis">mxGraphAnalysis</a>&nbsp;getInstance()</pre>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the sharedInstance.</dd>
</dl>
</li>
</ul>
<a id="setInstance(import hk.quantr.mxgraph.analysis.mxGraphAnalysis)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setInstance</h4>
<pre class="methodSignature">public static&nbsp;void&nbsp;setInstance&#8203;(<a href="mxGraphAnalysis.html" title="class in import hk.quantr.mxgraph.analysis">mxGraphAnalysis</a>&nbsp;instance)</pre>
<div class="block">Sets the shared instance of this class.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>instance</code> - The instance to set.</dd>
</dl>
</li>
</ul>
<a id="getShortestPath(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object,java.lang.Object,import hk.quantr.mxgraph.analysis.mxICostFunction,int,boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getShortestPath</h4>
<pre class="methodSignature">public&nbsp;java.lang.Object[]&nbsp;getShortestPath&#8203;(<a href="../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                                          java.lang.Object&nbsp;from,
                                          java.lang.Object&nbsp;to,
                                          <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf,
                                          int&nbsp;steps,
                                          boolean&nbsp;directed)</pre>
<div class="block">Returns the shortest path between two cells or their descendants
 represented as an array of edges in order of traversal. <br>
 This implementation is based on the Dijkstra algorithm.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>graph</code> - The object that defines the graph structure</dd>
<dd><code>from</code> - The source cell.</dd>
<dd><code>to</code> - The target cell (aka sink).</dd>
<dd><code>cf</code> - The cost function that defines the edge length.</dd>
<dd><code>steps</code> - The maximum number of edges to traverse.</dd>
<dd><code>directed</code> - If edge directions should be taken into account.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the shortest path as an alternating array of vertices
 and edges, starting with <code>from</code> and ending with
 <code>to</code>.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="#createPriorityQueue()"><code>createPriorityQueue()</code></a></dd>
</dl>
</li>
</ul>
<a id="getMinimumSpanningTree(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object[],import hk.quantr.mxgraph.analysis.mxICostFunction,boolean)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMinimumSpanningTree</h4>
<pre class="methodSignature">public&nbsp;java.lang.Object[]&nbsp;getMinimumSpanningTree&#8203;(<a href="../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                                                 java.lang.Object[]&nbsp;v,
                                                 <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf,
                                                 boolean&nbsp;directed)</pre>
<div class="block">Returns the minimum spanning tree (MST) for the graph defined by G=(E,V).
 The MST is defined as the set of all vertices with minimal lengths that
 forms no cycles in G.<br>
 This implementation is based on the algorihm by Prim-Jarnik. It uses
 O(|E|+|V|log|V|) time when used with a Fibonacci heap and a graph whith a
 double linked-list datastructure, as is the case with the default
 implementation.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>graph</code> - the object that describes the graph</dd>
<dd><code>v</code> - the vertices of the graph</dd>
<dd><code>cf</code> - the cost function that defines the edge length</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the MST as an array of edges</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="#createPriorityQueue()"><code>createPriorityQueue()</code></a></dd>
</dl>
</li>
</ul>
<a id="getMinimumSpanningTree(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object[],java.lang.Object[],import hk.quantr.mxgraph.analysis.mxICostFunction)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMinimumSpanningTree</h4>
<pre class="methodSignature">public&nbsp;java.lang.Object[]&nbsp;getMinimumSpanningTree&#8203;(<a href="../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                                                 java.lang.Object[]&nbsp;v,
                                                 java.lang.Object[]&nbsp;e,
                                                 <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf)</pre>
<div class="block">Returns the minimum spanning tree (MST) for the graph defined by G=(E,V).
 The MST is defined as the set of all vertices with minimal lenths that
 forms no cycles in G.<br>
 This implementation is based on the algorihm by Kruskal. It uses
 O(|E|log|E|)=O(|E|log|V|) time for sorting the edges, O(|V|) create sets,
 O(|E|) find and O(|V|) union calls on the union find structure, thus
 yielding no more than O(|E|log|V|) steps. For a faster implementatin</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>graph</code> - The object that contains the graph.</dd>
<dd><code>v</code> - The vertices of the graph.</dd>
<dd><code>e</code> - The edges of the graph.</dd>
<dd><code>cf</code> - The cost function that defines the edge length.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the MST as an array of edges.</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="#getMinimumSpanningTree(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object%5B%5D,import hk.quantr.mxgraph.analysis.mxICostFunction,boolean)"><code>getMinimumSpanningTree(mxGraph, Object[], mxICostFunction,
      boolean)</code></a>, 
<a href="#createUnionFind(java.lang.Object%5B%5D)"><code>createUnionFind(Object[])</code></a></dd>
</dl>
</li>
</ul>
<a id="getConnectionComponents(import hk.quantr.mxgraph.view.mxGraph,java.lang.Object[],java.lang.Object[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConnectionComponents</h4>
<pre class="methodSignature">public&nbsp;<a href="mxUnionFind.html" title="class in import hk.quantr.mxgraph.analysis">mxUnionFind</a>&nbsp;getConnectionComponents&#8203;(<a href="../view/mxGraph.html" title="class in import hk.quantr.mxgraph.view">mxGraph</a>&nbsp;graph,
                                           java.lang.Object[]&nbsp;v,
                                           java.lang.Object[]&nbsp;e)</pre>
<div class="block">Returns a union find structure representing the connection components of
 G=(E,V).</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>graph</code> - The object that contains the graph.</dd>
<dd><code>v</code> - The vertices of the graph.</dd>
<dd><code>e</code> - The edges of the graph.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the connection components in G=(E,V)</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="#createUnionFind(java.lang.Object%5B%5D)"><code>createUnionFind(Object[])</code></a></dd>
</dl>
</li>
</ul>
<a id="sort(import hk.quantr.mxgraph.view.mxCellState[],import hk.quantr.mxgraph.analysis.mxICostFunction)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sort</h4>
<pre class="methodSignature">public&nbsp;<a href="../view/mxCellState.html" title="class in import hk.quantr.mxgraph.view">mxCellState</a>[]&nbsp;sort&#8203;(<a href="../view/mxCellState.html" title="class in import hk.quantr.mxgraph.view">mxCellState</a>[]&nbsp;states,
                          <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf)</pre>
<div class="block">Returns a sorted set for <code>cells</code> with respect to
 <code>cf</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>states</code> - the cell states to sort</dd>
<dd><code>cf</code> - the cost function that defines the order</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns an ordered set of <code>cells</code> wrt.
         <code>cf</code></dd>
</dl>
</li>
</ul>
<a id="sum(import hk.quantr.mxgraph.view.mxCellState[],import hk.quantr.mxgraph.analysis.mxICostFunction)">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>sum</h4>
<pre class="methodSignature">public&nbsp;double&nbsp;sum&#8203;(<a href="../view/mxCellState.html" title="class in import hk.quantr.mxgraph.view">mxCellState</a>[]&nbsp;states,
                  <a href="mxICostFunction.html" title="interface in import hk.quantr.mxgraph.analysis">mxICostFunction</a>&nbsp;cf)</pre>
<div class="block">Returns the sum of all cost for <code>cells</code> with respect to
 <code>cf</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>states</code> - the cell states to use for the sum</dd>
<dd><code>cf</code> - the cost function that defines the costs</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns the sum of all cell cost</dd>
</dl>
</li>
</ul>
<a id="createUnionFind(java.lang.Object[])">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>createUnionFind</h4>
<pre class="methodSignature">protected&nbsp;<a href="mxUnionFind.html" title="class in import hk.quantr.mxgraph.analysis">mxUnionFind</a>&nbsp;createUnionFind&#8203;(java.lang.Object[]&nbsp;v)</pre>
<div class="block">Hook for subclassers to provide a custom union find structure.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>v</code> - the array of all elements</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Returns a union find structure for <code>v</code></dd>
</dl>
</li>
</ul>
<a id="createPriorityQueue()">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>createPriorityQueue</h4>
<pre class="methodSignature">protected&nbsp;<a href="mxFibonacciHeap.html" title="class in import hk.quantr.mxgraph.analysis">mxFibonacciHeap</a>&nbsp;createPriorityQueue()</pre>
<div class="block">Hook for subclassers to provide a custom fibonacci heap.</div>
</li>
</ul>
</li>
</ul>
</section>
</li>
</ul>
</div>
</div>
</main>
<!-- ========= END OF CLASS DATA ========= -->
<footer role="contentinfo">
<nav role="navigation">
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a id="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a id="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../index.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="class-use/mxGraphAnalysis.html">Use</a></li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
<div class="aboutLanguage"><p><b>JGraph X 4.2.2</b></p></div>
</div>
<div class="subNav">
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.summary">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li><a href="#constructor.detail">Constr</a>&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a id="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
</nav>
<p class="legalCopy"><small><font size=1>Copyright (c) 2010 <a href="http://www.mxgraph.com/"
				target="_blank">Gaudenz Alder</a>. All rights reserved.</font></small></p>
</footer>
</body>
</html>
